org.jboss.resteasy.plugins.providers.jaxb.json

## Class JsonMapProvider

- java.lang.Object
- - org.jboss.resteasy.plugins.providers.jaxb.MapProvider
  - - org.jboss.resteasy.plugins.providers.jaxb.json.JsonMapProvider

- All Implemented Interfaces:
    MessageBodyReader<Object>, MessageBodyWriter<Object>

      @Provider
      @Produces(value="application/*+json")
      @Consumes(value="application/*+json")
      public class JsonMapProvider
      extends MapProvider

  Version:
    $Revision: 1 $
  Author:
    Bill Burke

- - ### Field Summary

    - ### Fields inherited from class org.jboss.resteasy.plugins.providers.jaxb.MapProvider

      `providers`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JsonMapProvider()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static String` | `getCharset(MediaType mediaType)`
    `Object` | `readFrom(Class<Object> type, Type genericType, Annotation[] annotations, MediaType mediaType, MultivaluedMap<String,String> httpHeaders, InputStream entityStream)` Read a type from the `InputStream`.
    `void` | `writeTo(Object target, Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType, MultivaluedMap<String,Object> httpHeaders, OutputStream entityStream)` Write a type to an HTTP message.

    - ### Methods inherited from class org.jboss.resteasy.plugins.providers.jaxb.MapProvider

      `getFinder, getJAXBObject, getSize, isDisableDTDs, isDisableExternalEntities, isEnableSecureProcessingFeature, isReadable, isWrapped, isWriteable, needsSecurity, setDisableDTDs, setDisableExternalEntities, setEnableSecureProcessingFeature`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### JsonMapProvider

          public JsonMapProvider()

  - ### Method Detail

    - #### readFrom

          public Object readFrom(Class<Object> type,
                        Type genericType,
                        Annotation[] annotations,
                        MediaType mediaType,
                        MultivaluedMap<String,String> httpHeaders,
                        InputStream entityStream)
                          throws IOException,
                                 WebApplicationException

      Description copied from interface: `MessageBodyReader`
      Read a type from the `InputStream`.

      In case the entity input stream is empty, the reader is expected to either return a Java representation of a zero-length entity or throw a `NoContentException` in case no zero-length entity representation is defined for the supported Java type. A `NoContentException`, if thrown by a message body reader while reading a server request entity, is automatically translated by JAX-RS server runtime into a `BadRequestException` wrapping the original `NoContentException` and rethrown for a standard processing by the registered `exception mappers`.

      Specified by:
        `readFrom` in interface `MessageBodyReader<Object>`
      Overrides:
        `readFrom` in class `MapProvider`
      Parameters:
        `type` - the type that is to be read from the entity stream.
        `genericType` - the type of instance to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Method.getGenericParameterTypes`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Method.getParameterAnnotations`.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - the read-only HTTP headers associated with HTTP entity.
        `entityStream` - the `InputStream` of the HTTP entity. The caller is responsible for ensuring that the input stream ends when the entity has been consumed. The implementation should not close the input stream.
      Returns:
        the type that was read from the stream. In case the entity input stream is empty, the reader is expected to either return an instance representing a zero-length entity or throw a `NoContentException` in case no zero-length entity representation is defined for the supported Java type.
      Throws:
        `IOException` - if an IO error arises. In case the entity input stream is empty and the reader is not able to produce a Java representation for a zero-length entity, `NoContentException` is expected to be thrown.
        `WebApplicationException` - if a specific HTTP error response needs to be produced. Only effective if thrown prior to the response being committed.

    - #### getCharset

          public static String getCharset(MediaType mediaType)

    - #### writeTo

          public void writeTo(Object target,
                     Class<?> type,
                     Type genericType,
                     Annotation[] annotations,
                     MediaType mediaType,
                     MultivaluedMap<String,Object> httpHeaders,
                     OutputStream entityStream)
                       throws IOException,
                              WebApplicationException

      Description copied from interface: `MessageBodyWriter`
      Write a type to an HTTP message. The message header map is mutable but any changes must be made before writing to the output stream since the headers will be flushed prior to writing the message body.
      Specified by:
        `writeTo` in interface `MessageBodyWriter<Object>`
      Overrides:
        `writeTo` in class `MapProvider`
      Parameters:
        `target` - the instance to write.
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - a mutable map of the HTTP message headers.
        `entityStream` - the `OutputStream` for the HTTP entity. The implementation should not close the output stream.
      Throws:
        `IOException` - if an IO error arises.
        `WebApplicationException` - if a specific HTTP error response needs to be produced. Only effective if thrown prior to the message being committed.

Copyright © 2014. All Rights Reserved.